"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var puppeteer_1 = __importDefault(require("puppeteer"));
var Engine = /** @class */ (function () {
    function Engine(responseCache) {
        this.responseCache = responseCache;
        this.handleInterceptors = this.handleInterceptors.bind(this);
        this.onResponse = this.onResponse.bind(this);
        this.onRequest = this.onRequest.bind(this);
        this.init = this.init.bind(this);
    }
    Engine.prototype.init = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, puppeteer_1.default.launch(__assign({ headless: true, ignoreHTTPSErrors: true, devtools: false }, config, { args: ['--disable-gpu', '--no-sandbox', '--disable-dev-shm-usage'] }))];
                    case 1:
                        _a.browser = _b.sent();
                        this.browser.on("disconnected", this.init);
                        return [2 /*return*/];
                }
            });
        });
    };
    Engine.prototype.createPage = function (emulateOptions, interceptors, followRedirects) {
        return __awaiter(this, void 0, void 0, function () {
            var browserPage;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.browser.newPage()];
                    case 1:
                        browserPage = _a.sent();
                        return [4 /*yield*/, browserPage.emulate(emulateOptions)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, browserPage._client.send('Network.setBypassServiceWorker', { bypass: true })];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, browserPage._client.send('Network.setCacheDisabled', {
                                cacheDisabled: false
                            })];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, browserPage.setRequestInterception(true)];
                    case 5:
                        _a.sent();
                        browserPage.on('request', function (request) { return _this.onRequest(request, interceptors, browserPage, followRedirects); });
                        browserPage.on('response', this.onResponse);
                        return [2 /*return*/, browserPage];
                }
            });
        });
    };
    Engine.prototype.render = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var browserPage, renderResult, error_1, navigationResult, _a, _b, hook, e_1_1, pageContent, e_2, redirectRequest, headers, status_1, base, redirection;
            var e_1, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        renderResult = {
                            status: 503,
                            html: ''
                        };
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.createPage(options.emulateOptions, options.interceptors, options.followRedirects)];
                    case 2:
                        browserPage = _d.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _d.sent();
                        return [2 /*return*/, renderResult];
                    case 4:
                        _d.trys.push([4, 16, , 17]);
                        return [4 /*yield*/, browserPage.goto(options.url, { waitUntil: options.waitMethod })];
                    case 5:
                        navigationResult = _d.sent();
                        if (!navigationResult) return [3 /*break*/, 15];
                        if (!(typeof options.hooks != "undefined" && options.hooks.length > 0)) return [3 /*break*/, 13];
                        _d.label = 6;
                    case 6:
                        _d.trys.push([6, 11, 12, 13]);
                        _a = __values(options.hooks), _b = _a.next();
                        _d.label = 7;
                    case 7:
                        if (!!_b.done) return [3 /*break*/, 10];
                        hook = _b.value;
                        return [4 /*yield*/, hook.handle(browserPage)];
                    case 8:
                        _d.sent();
                        _d.label = 9;
                    case 9:
                        _b = _a.next();
                        return [3 /*break*/, 7];
                    case 10: return [3 /*break*/, 13];
                    case 11:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 13];
                    case 12:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 13: return [4 /*yield*/, browserPage.content()];
                    case 14:
                        pageContent = _d.sent();
                        renderResult.status = navigationResult.status();
                        renderResult.html = pageContent;
                        _d.label = 15;
                    case 15: return [3 /*break*/, 17];
                    case 16:
                        e_2 = _d.sent();
                        if (options.followRedirects && browserPage.redirect) {
                            redirectRequest = browserPage.redirect;
                            headers = redirectRequest.headers();
                            status_1 = redirectRequest.status();
                            base = new URL(options.url);
                            redirection = new URL(headers.location, base.origin);
                            redirection.searchParams.delete("dr");
                            headers.location = redirection.href;
                            renderResult.status = status_1;
                            renderResult.headers = headers;
                        }
                        return [3 /*break*/, 17];
                    case 17: return [4 /*yield*/, browserPage.close()];
                    case 18:
                        _d.sent();
                        return [2 /*return*/, renderResult];
                }
            });
        });
    };
    Engine.prototype.handleInterceptors = function (interceptors, request) {
        return __awaiter(this, void 0, void 0, function () {
            var handled, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        handled = false;
                        i = 0;
                        while (!handled && i < interceptors.length) {
                            interceptors[i++].handle(request, function (options) {
                                request.respond(options);
                                handled = true;
                            }, function () {
                                request.abort('blockedbyclient');
                                handled = true;
                            });
                        }
                        if (!!handled) return [3 /*break*/, 2];
                        return [4 /*yield*/, request.continue()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    Engine.prototype.onResponse = function (response) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.responseCache.setCache(response)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Engine.prototype.onRequest = function (request, interceptors, browserPage, followRedirects) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (followRedirects && request.isNavigationRequest() && request.redirectChain().length && request.resourceType() === 'document') {
                            browserPage.redirect = request.redirectChain()[0].response();
                            return [2 /*return*/, request.abort()];
                        }
                        return [4 /*yield*/, this.responseCache.request(request)];
                    case 1:
                        if (_a.sent())
                            return [2 /*return*/];
                        if (typeof interceptors !== "undefined" && interceptors.length > 0) {
                            this.handleInterceptors(interceptors, request);
                        }
                        else {
                            return [2 /*return*/, request.continue()];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return Engine;
}());
exports.Engine = Engine;
