"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var defaultPageSettings = {
    hooks: [],
    interceptors: [],
    cacheDurationSeconds: 0,
    emulateOptions: {
        userAgent: 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1',
        viewport: {
            width: 414,
            height: 736,
            deviceScaleFactor: 3,
            isMobile: true,
            hasTouch: true,
            isLandscape: false
        }
    },
    waitMethod: "load",
    query: {},
    followRedirects: true,
};
var Page = /** @class */ (function () {
    function Page(configuration, engine, plugins) {
        if (plugins === void 0) { plugins = []; }
        this.configuration = __assign({}, defaultPageSettings, configuration);
        this.plugins = plugins;
        this.handle = this.handle.bind(this);
        this.engine = engine;
    }
    Page.prototype.convertRequestToUrl = function (req) {
        var e_1, _a;
        var url = new URL("" + req.application.origin + req.url);
        try {
            for (var _b = __values(Object.entries(this.configuration.query)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
                url.searchParams.append(key, value);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return url.toString();
    };
    Page.prototype.handle = function (req, res) {
        return __awaiter(this, void 0, void 0, function () {
            var url, content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.convertRequestToUrl(req);
                        return [4 /*yield*/, this.onBeforeRender(this, req.originalUrl, res)];
                    case 1:
                        if (_a.sent())
                            return [2 /*return*/];
                        return [4 /*yield*/, this.engine.render({
                                emulateOptions: this.configuration.emulateOptions,
                                url: url,
                                interceptors: this.configuration.interceptors,
                                hooks: this.configuration.hooks,
                                waitMethod: this.configuration.waitMethod,
                                followRedirects: this.configuration.followRedirects
                            })];
                    case 2:
                        content = _a.sent();
                        return [4 /*yield*/, this.onAfterRender(this, req.originalUrl, res, content)];
                    case 3:
                        _a.sent();
                        this.handleRenderResponse(content, res);
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.onBeforeRender = function (page, url, res) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, plugin, pluginResponse, e_2_1;
            var e_2, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 5, 6, 7]);
                        _a = __values(this.plugins), _b = _a.next();
                        _d.label = 1;
                    case 1:
                        if (!!_b.done) return [3 /*break*/, 4];
                        plugin = _b.value;
                        if (!plugin.onBeforeRender) return [3 /*break*/, 3];
                        return [4 /*yield*/, plugin.onBeforeRender(page, url)];
                    case 2:
                        pluginResponse = _d.sent();
                        if (pluginResponse) {
                            return [2 /*return*/, this.handleRenderResponse(pluginResponse, res)];
                        }
                        _d.label = 3;
                    case 3:
                        _b = _a.next();
                        return [3 /*break*/, 1];
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        e_2_1 = _d.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 7];
                    case 6:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.onAfterRender = function (page, url, res, content) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(this.plugins.map(function (plugin) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                if (plugin.onAfterRender && content) {
                                    return [2 /*return*/, plugin.onAfterRender(page, url, content, res)];
                                }
                                return [2 /*return*/];
                            });
                        }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Page.prototype.handleRenderResponse = function (content, res) {
        if (content.status === 200 && this.configuration.cacheDurationSeconds) {
            res.set('cache-control', "max-age=" + this.configuration.cacheDurationSeconds + ", public");
        }
        if (content.headers && content.headers.location) {
            res
                .set('location', content.headers.location)
                .status(content.status)
                .end();
        }
        else {
            res
                .status(content.status)
                .send(content.html);
        }
        return content;
    };
    Page.prototype.toJSON = function () {
        return {
            matcher: this.configuration.matcher,
            interceptors: this.configuration.interceptors.map(function (i) { return i.name; }),
            hooks: this.configuration.hooks.map(function (i) { return i.name; }),
            waitMethod: this.configuration.waitMethod,
            emulateOptions: this.configuration.emulateOptions,
            query: this.configuration.query,
            followRedirects: this.configuration.followRedirects,
        };
    };
    return Page;
}());
exports.Page = Page;
