"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var shrink_ray_current_1 = __importDefault(require("shrink-ray-current"));
var setDynamicRenderHeader = function (req, res, next) {
    res.setHeader('x-powered-by', 'dynamic-rendering');
    next();
};
exports.setDynamicRenderHeader = setDynamicRenderHeader;
var Server = /** @class */ (function () {
    function Server() {
        this.app = express_1.default();
        this.app.use(shrink_ray_current_1.default());
        this.app.use(setDynamicRenderHeader);
    }
    Server.prototype.listen = function (port) {
        var _this = this;
        return new Promise(function (resolve) {
            console.log('Server call');
            _this.app.listen(port, function () {
                resolve(port);
            });
        });
    };
    Server.prototype.register = function (path, method, handler) {
        this.app[method](path, handler);
    };
    Server.prototype.router = function (path, router) {
        this.app.use(path, router);
    };
    return Server;
}());
exports.Server = Server;
